populate: add _require_populate_commands to check for tools
[xfstests-dev.git] / tests / xfs / 069
1 #! /bin/bash
2 # FS QA Test No. 069
3 #
4 # Determine whether the extent size hint can be set on directories
5 # with allocated extents correctly.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2014 Google Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 15
33
34 _cleanup()
35 {
36     cd /
37     rm -f $tmp.*
38 }
39
40 # get standard environment, filters and checks
41 . ./common/rc
42 . ./common/filter
43 . ./common/punch
44
45 # real QA test starts here
46
47 # Modify as appropriate.
48 _supported_fs xfs
49 _supported_os Linux
50 _require_scratch
51
52 _scratch_mkfs_xfs >/dev/null 2>&1
53 _scratch_mount
54
55 small=$SCRATCH_MNT/small
56 big=$SCRATCH_MNT/big
57
58 # sanity check on a small directory
59 mkdir $small
60 # expect that an empty directory has no extents
61 $XFS_IO_PROG -c "bmap" $small | _filter_scratch
62 # and that we can set an extent size on it
63 $XFS_IO_PROG -c 'extsize 8m' $small
64 # and finally check that the extent size update has taken place
65 $XFS_IO_PROG -c "extsize" $small | _filter_scratch
66
67 # now create a 'big' (with extents) directory
68 mkdir $big
69 for idx in {0..1000}; do
70     touch $big/$idx
71 done
72 $XFS_IO_PROG -c 'bmap -vp' $big | _filter_bmap | \
73     grep -q '^0: .*data'
74 [ $? -eq 0 ] || echo "Can't force allocating extents!" 1>&2
75
76 # expect that we can set the extent size on $big as well
77 $XFS_IO_PROG -c 'extsize 8m' $big | _filter_scratch
78 # and that it took effect
79 $XFS_IO_PROG -c 'extsize' $big | _filter_scratch
80
81 # success, all done
82 status=0
83 exit